//  yv122nv12.cpp
//
//	YV12 to NV12 converter
//
//	Copyright (c)
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include "yv122nv12.h"


extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}


//͂̃`FbN
HRESULT Cyv122nv12::CheckInputType(const CMediaType *mtIn)
{
    if (mtIn->majortype != MEDIATYPE_Video)
	{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    if (mtIn->subtype != MEDIASUBTYPE_YV12)
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	BITMAPINFOHEADER *pbmi;
	if (mtIn->formattype == FORMAT_VideoInfo){
		if(mtIn->cbFormat < sizeof(VIDEOINFOHEADER)) {
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
		pbmi = &(((VIDEOINFOHEADER *)(mtIn->Format()))->bmiHeader);
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2){
		if(mtIn->cbFormat < sizeof(VIDEOINFOHEADER2)) {
			return VFW_E_TYPE_NOT_ACCEPTED;
		}
		pbmi = &(((VIDEOINFOHEADER2 *)(mtIn->Format()))->bmiHeader);
	} else {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	if (pbmi->biCompression != FCC('YV12')){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}

    // ׂĖȂB
    return S_OK;
}

//o͌`̒
HRESULT Cyv122nv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
    ASSERT(m_pInput->IsConnected());
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }
    if (iPosition == 0)
    {
        HRESULT hr = m_pInput->ConnectionMediaType(pMediaType);
        if (FAILED(hr))
        {
            return hr;
        }
        pMediaType->subtype = MEDIASUBTYPE_NV12;

		//BITMAPINFOHEADERł̃^Cvw
        BITMAPINFOHEADER *pbmi;
		if (pMediaType->formattype == FORMAT_VideoInfo){
			pbmi = &((VIDEOINFOHEADER *)(pMediaType->Format()))->bmiHeader;
		}
		else if (pMediaType->formattype == FORMAT_VideoInfo2){
			pbmi = &((VIDEOINFOHEADER2 *)(pMediaType->Format()))->bmiHeader;
		}

		pbmi->biCompression = FCC('NV12');

        return S_OK;
    }
    // else
    return VFW_S_NO_MORE_ITEMS;
}

//`FbN
HRESULT Cyv122nv12::CheckTransform(
    const CMediaType *mtIn, const CMediaType *mtOut)
{

	BITMAPINFOHEADER *pbmi;
	if (mtIn->formattype == FORMAT_VideoInfo){
		pbmi = &((VIDEOINFOHEADER *)(mtIn->Format()))->bmiHeader;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2){
		pbmi = &((VIDEOINFOHEADER2 *)(mtIn->Format()))->bmiHeader;
	}

	w = abs(pbmi->biWidth);
	h = abs(pbmi->biHeight);

	//geforce͂Ȃł͂
	if (mtOut->formattype == FORMAT_VideoInfo){
		pbmi = &((VIDEOINFOHEADER *)(mtOut->Format()))->bmiHeader;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2){
		pbmi = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->bmiHeader;
	}
	if(w != abs(pbmi->biWidth) || h != abs(pbmi->biHeight)){

		return VFW_E_INVALIDMEDIATYPE;
	}

	//܂Ȃ̂Ń`FbNȂ
	/*
	CMediaType *mtIn2 = new CMediaType(*mtIn);

	mtIn2->subtype = MEDIASUBTYPE_NV12;

	BITMAPINFOHEADER *pbmi;
	if (mtIn2->formattype == FORMAT_VideoInfo){
		pbmi = &((VIDEOINFOHEADER *)(mtIn2->Format()))->bmiHeader;
	}
	else if (mtIn2->formattype == FORMAT_VideoInfo2){
		pbmi = &((VIDEOINFOHEADER2 *)(mtIn2->Format()))->bmiHeader;
	}

	pbmi->biCompression = FCC('NV12');
    
    if (*mtIn2 != *mtOut)
    {
		delete mtIn2;
        return VFW_E_INVALIDMEDIATYPE;
    }
	
	delete mtIn2;
	
	*/
	
    // ׂĖȂB
    return S_OK;
}

HRESULT Cyv122nv12::DecideBufferSize(
    IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
    AM_MEDIA_TYPE mt;
    HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
    if (FAILED(hr))
    {
        return hr;
    }

    //BITMAPINFOHEADERTCY𓾂
    BITMAPINFOHEADER *pbmi;
	if (mt.formattype == FORMAT_VideoInfo){
		if(mt.cbFormat < sizeof(VIDEOINFOHEADER)) {
			return E_UNEXPECTED;
		}
		pbmi = &((VIDEOINFOHEADER *)(mt.pbFormat))->bmiHeader;
	} else if (mt.formattype == FORMAT_VideoInfo2){
		if(mt.cbFormat < sizeof(VIDEOINFOHEADER2)) {
			return E_UNEXPECTED;
		}
		pbmi = &((VIDEOINFOHEADER2 *)(mt.pbFormat))->bmiHeader;
	} else {
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}
	//őH
    pProp->cbBuffer = DIBSIZE(*pbmi); 
    if (pProp->cbAlign == 0)
    {
        pProp->cbAlign = 1;
    }
    if (pProp->cBuffers == 0)
    {
        pProp->cBuffers = 1;
    }
    // tH[}bg ubNB
    FreeMediaType(mt);

    // AP[^ vpeBݒ肷B
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp, &Actual);
    if (FAILED(hr)) 
    {
        return hr;
    }
    // ꍇAۂ̌ʂmFB
    if (pProp->cbBuffer > Actual.cbBuffer) 
    {
        return E_FAIL;
    }
    return S_OK;
}

//ۂ̕ϊ
HRESULT Cyv122nv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
    // ɂȂobt@ւ̃|C^擾B
    BYTE *pBufferIn, *pBufferOut;
    HRESULT hr = pSource->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pDest->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }
    // f[^B

	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());

	yv12_2_nv12(pBufferOut, pBufferIn, w, h);

    pDest->SetSyncPoint(TRUE);
    return S_OK;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_YV122NV12,           // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // Dsf
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_YV122NV12);
        pFM2->Release();
    }
    return hr;
}


CUnknown *Cyv122nv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
    Cyv122nv12 *pFilter = new Cyv122nv12(NAME("YV12 to NV12 converter"), pUnk);
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}

/*
 * YV12 -> NV12
 * Cɂ 
 */
void yv12_2_nv12(BYTE *pBufferOut, BYTE *pBufferIn, LONG imgWidth, LONG imgHeight)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = imgWidth >> 1;
	int hHeight = imgHeight >> 1;
	int offsY = imgWidth * imgHeight;
	int offsYV = offsY >> 2;

	//ỸRs[
	CopyMemory(pBufferOut, pBufferIn, offsY);
	
	pBufferOut += offsY;
	pBufferIn += offsY;

	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
	}
	
}